/***************************************************************************/
/*    Uebung 14                                                            */
/*                                                                         */
/*    PL/SQL-Programmierung                                                */
/*                                                                         */
/*    Version 2  fr Oracle 11g und SQL Developer 2.1                      */
/*                                                                         */
/***************************************************************************/
CREATE OR REPLACE FUNCTION BEST_LNR(P_ANR IN CHAR) RETURN NUMBER IS
  
   Z_LNR    liefert.LNR%TYPE;
   Z_Preis  liefert.Preis%TYPE;  

BEGIN

   select LNR        into Z_LNR   from Artikel where ANR=P_ANR;
   select MIN(Preis) into Z_Preis from liefert where ANR = P_ANR;

   select MIN(LNR)   into Z_LNR   from liefert where Preis = Z_Preis and ANR = P_ANR;
      
   return Z_LNR;

EXCEPTION

   WHEN NO_DATA_FOUND  THEN
	return NULL; 
End;
/
select ANR, Bezeichnung, BEST_LNR(ANR) as LNR from product;

/***************************************************************************/
/*                                                                         */
/*    Interessante Loesungs-Variante eines Teilnehmers                     */
/*                                                                         */
/***************************************************************************/

create or replace FUNCTION BEST_LNR_VAR(IN_ANR CHAR) RETURN NUMBER IS
  ret NUMBER(2);
  cursor lesen is select anr, preis, lnr from liefert where anr=IN_ANR order by preis, lnr;
BEGIN
  ret:=NULL;

  FOR daten IN lesen 
  LOOP
      ret:=daten.lnr;
      exit;
  END LOOP;

  RETURN ret;

END BEST_LNR_VAR;
/

select ANR, Bezeichnung, BEST_LNR_VAR(ANR) as LNR from product;
